SuperStrict

Const WIDTH:Int = 1200
Const URL:String = "www.spiegel.de/schlagzeilen/tops/index.rss"
Const FONT:String = "C:/Windows/Fonts/Arial.ttf"

SeedRnd MilliSecs()
AppTitle = "SPIEGEL ONLINE RSS TICKER"
Graphics WIDTH,30
SetBlend ALPHABLEND

SetImageFont LoadImageFont(FONT, 16)
Local timer:TTimer = CreateTimer(30)

Local ticker:TTicker = New TTicker
ticker.update()

Global mouse:Byte
Repeat
	
	Cls
	mouse = MouseHit(1)
	SetColor 128,128,128
	DrawRect 0,0,GraphicsWidth(), GraphicsHeight()
	'DrawText "foobar", 0, 10
	ticker.draw()
	
	
	Flip 0
	WaitTimer(timer)
	
	
Until KeyHit(KEY_ESCAPE) Or AppTerminate()
End

Type TTicker
	

	Field offset:Int = GraphicsWidth()
	Field idx:Int = 0
	Field content:String = "   +++   "
	Field news:TList = New TList
	Field parser:TNewsParser = New TNewsParser
	
	
	Method draw()
		

		Local hoveredMsg:TNews = Null
		Local hovered:Byte = MouseX() > offset And MouseX() < offset + TextWidth(content) And MouseY() > 8 And MouseY() < 8+TextHeight(content) 
		If Not hovered Then
		
			offset :- 2
			
		Else
			hoveredMsg = getHoveredMsg()
		EndIf
		
		If offset + TextWidth(content[0..1]) < 0 Then
			Local s:String = Chr(content[0])
			content = content[1..]
			offset :+ TextWidth(s)
			
			For Local msg:TNews = EachIn news
				msg.idx :- 1
			Next
			
		EndIf
		
		If offset + TextWidth(content) < GraphicsWidth() Then
			Local msg:TNews = TNews(news.ValueAtIndex(idx))
			msg.idx = content.length
			msg.l = msg.title.length
			content = content + msg.title + "   +++   "
			
			idx :+ 1
			If idx >= news.Count() Then
				idx = 0
			EndIf
		EndIf
		
		SetColor 0,0,0
		DrawText content, offset+1, 8
		SetColor 255,255,255
		DrawText content, offset, 6

		If hoveredMsg Then
			SetColor 0,0,0
			DrawLine offset+1+TextWidth(content[..hoveredMsg.idx]), 26 , offset+TextWidth(content[..hoveredMsg.idx+hoveredMsg.l]), 26
			SetColor 255,255,255
			DrawLine offset+TextWidth(content[..hoveredMsg.idx]), 24 , offset+TextWidth(content[..hoveredMsg.idx+hoveredMsg.l]), 24
			
			If mouse Then OpenURL(hoveredMsg.url)
		
		EndIf		
	End Method
	
	Method update()
		news.clear()

		parser.ticker = Self
		parser.update()
		news.sort(True, randSort)

	End Method

	Method getHoveredMsg:TNews()
		Local tw:Int
		For Local msg:TNews = EachIn news
			If msg.idx = -1 Then Continue
			tw = TextWidth(content[..msg.idx])
			If MouseX() > offset + tw And MouseX() < offset + TextWidth(content[..msg.idx+msg.l]) Then
				Return msg
			EndIf
		Next			
		
	End Method	
	
	
	Method addNews(msg:TNews)
		news.AddLast(msg)
	End Method
	
End Type

Type TNews
	Field idx:Int = -1
	Field l:Int
	
	Field title:String
	Field url:String
	
End Type

Type TNewsParser
	
	Field ticker:TTicker
	Field content:String
	Field news:TNews
	
	Field titleActive:Byte
	Field urlActive:Byte	
	
	Method update()
		
		content = ""
		Local stream:TStream = OpenStream("http::"+URL)
		
		While Not Eof(stream)
			content :+ stream.ReadLine()
		Wend
		
		'Print content
		parseContent()
		
		
	End Method
	
	Method parseContent()
	
		Local skip:String
		Local i:Int = 0
		
		Local s:Int
		While i < content.length
		
			s = content[i]
			'Print s
			
			Select s
				Case 60 '<
					i = parseNewTag(i)
				Default
					If news <> Null Then
					
						If titleActive Then
							news.title :+ Chr(s)
						EndIf
						If urlActive Then
							news.url :+ Chr(s)
						EndIf
					EndIf
				
					i:+1					
			End Select							
		Wend
		
	End Method
	
	Method parseNewTag:Int(i:Int)
		Local j:Int
		Local tag:String
		
		'check for <?
		If content[i+1] = 63 Then
			i = content.find("?>",i)
			i :+ 2
			Return i
		EndIf
		
		'check for <![CDATA[
		If content[i..i+9] = "<![CDATA[" Then
			i:+9
			Return i
		EndIf
		
		'check for closing tag (</)
		If content[i+1] = 47 Then
			
			j= content.find(">", i)
			tag = content[i..j+1]
			Select tag
				Case "</item>"
					ticker.addNews(news)
					news = Null
				Case "</title>"
					titleActive = Null
				Case "</link>"
					urlActive = Null
			End Select

			i = j+1
			Return i
			
		EndIf
	
		'check for open tag
		j= content.find(">", i)
		tag = content[i..j+1]
		Select tag 
			Case "<item>"
				news = New TNews				
			Case "<title>"
				If news <> Null Then
					titleActive = True
				EndIf
			Case "<link>"
				If news <> Null Then
					urlActive = True
				EndIf
		End Select
		
		i = j+1
		Return i
		
	End Method
	
End Type

Function randSort:Int(o1:Object, o2:Object)
	Return Rand(-1,1)
End Function	